package com.fly.game.llk;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

public class GameBody extends JPanel{
	
	//连连看的图片
	private ImageIcon[] images;
	//背景图片
	private Image backgroundImage;
	
	//连连看数据
	private int[][] data = new int[10][10];
	//每格大小
	final int Size = 50;
	
	public GameBody(){
		initGame();
	}
	
	public int[][] getData(){
		return data;
	}
	
	public void initGame(){
		initData();
		initImg();
	}
	
	
	public void paint(Graphics g){
		super.paint(g);
		
		g.drawImage(backgroundImage, 0, 0, null);
		
		for(int i=0; i<10; i++){
			for(int j=0; j<10; j++){
				if(data[i][j] != 0){
					//g.drawImage(images[data[i][j]].getImage(), i*Size+1, j*Size+1,Size,Size, null);
					g.drawImage(images[data[i][j]].getImage(), i*Size+2, j*Size+2, (i+1)*Size, (j+1)*(Size), 0,0,48,48, null);
				}
				
			}
		}
		
		
	}
	//加载图片
	private void initImg() {
		// TODO Auto-generated method stub
		images = new ImageIcon[11];
		for(int i=1; i<11; i++){
			System.out.println(this.getClass().getResource("imgs/"+i+".png"));
			images[i] = new ImageIcon(this.getClass().getResource("imgs/"+i+".png"));
		}
		
		backgroundImage = new ImageIcon(this.getClass().getResource("imgs/bk.png")).getImage();
		
	}
	//初始化数据
	private void initData(){
		int count = 10*10/2;
		Random rand = new Random();
		for(int i=0; i<count; i++){
			int type = rand.nextInt(10)+1;
			createPosition(rand,type);
			createPosition(rand,type);
		}
	}
	//随机一个位置
	private void createPosition(Random rand,int type){
		
		int x;
		int y;
		do{
			x = rand.nextInt(10);
			y = rand.nextInt(10);
		}while(data[x][y] !=0 );
		
		data[x][y] = type;
	}
}
