package com.fly.game.llk;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;

public class GameListener extends MouseAdapter{
	final int SIZE = 50;
	
	private int[][] data;
	/**用于检验两点之间是否相通的数组*/
	private int[][] checkArr;
	private int count = 1;
	private int x1,y1,x2,y2;
	private JPanel jp;
	private Graphics g;
	
	GameListener(int[][] data,JPanel jp){
		this.data = data;
		this.jp = jp;
		g = jp.getGraphics();
		/*checkArr比数据数组大了一圈，所以行列均比普通数组大2
		*比如数据数组data为：   那么checkArr为：
		*				0,0,0,0,0
		*	2,3,2		0,2,3,2,0
		*	2,3,4		0,2,3,4,0
		*   2,2,4		0,2,2,4,0
		*				0,0,0,0,0
		*/
		checkArr = new int[data.length+2][data.length+2];
		for(int i=0; i<data.length; i++){
			for(int j=0; j<data.length; j++){
				checkArr [i+1][j+1] = data[i][j];
			}
			
		}
	}
	public void mouseClicked(MouseEvent e) {
		int tempX = e.getX()/SIZE;
		int tempY = e.getY()/SIZE;
		
		if(data[tempX][tempY]  == 0){//点击空白
			count = 1;
		}else{
			if(count == 1){//第一次点击
				x1 = tempX;
				y1 = tempY;
				count++;
			}else{
				if(x1 != tempX || y1 != tempY){//第二次点击并且和第一次位置不同
					x2 = tempX;
					y2 = tempY;
					if(data[x1][y1] == data[x2][y2]){//两次相同
						if(check()){
							data[x1][y1] = 0;
							data[x2][y2] = 0;
							checkArr[x1+1][y1+1] = 0;
							checkArr[x2+1][y2+1] = 0;
							//pause(500);
							jp.repaint();
						}
					}
					count = 1;
				}
			}
		}
		
		
		
		System.out.print(count+":"+tempX+" "+tempY);
		System.out.println(" "+data[tempX][tempY]);
		
	}
	
	/**
	 * 检查两个点之间是否相通
	 * @return 如果两点相通返回true，否则返回false
	 */
	private boolean check(){
		
		//没有拐角
		if( zore(x1+1,y1+1,x2+1,y2+1) ){
			System.out.println("0一样");
			return true;
		}
		//一个拐角
		if(one(x1+1,y1+1,x2+1,y2+1)){
			System.out.println("1一样");
			return true;
		}
		//两个拐角
		return two(x1+1,y1+1,x2+1,y2+1);
		
		
	}
	
	//没有拐角的判定
	private boolean zore(int x1,int y1,int x2,int y2){
		if(x1 != x2 && y1 != y2){//两点如果不在同一水平线或者垂直线，则不可能为没有拐角相通
			return false;
		}
		if(x1 == x2){//判断两点水平之间是否全空白
			int minY = Math.min(y1, y2);
			int maxY = Math.max(y1, y2);
			for(int i=minY+1; i<maxY; i++){
				if(checkArr[x1][i] !=0){
					return false;
				}
			}
		}else if(y1 == y2){//判断两点垂直之间是否全空白
			int minX = Math.min(x1, x2);
			int maxX = Math.max(x1, x2);
			for(int i=minX+1; i<maxX; i++){
				if(checkArr[i][y1] !=0){
					return false;
				}
			}
		}
		//能执行到这里说明两点之间全是空白，所以返回true
		return true;
	}
	
	//一个拐角的判定
	private boolean one(int x1,int y1,int x2,int y2){
		if(x1 == x2 || y1 == y2 ){//一个拐角需要两个坐标均不相等
			return false;
		}
		return ( checkArr[x1][y2]==0 &&zore(x1,y1,x1,y2)&&zore(x1,y2,x2,y2) )
		||(checkArr[x2][y1]==0 && zore(x1,y1,x2,y1)&&zore(x2,y1,x2,y2) );
		
	}
	
	//两个拐角的判定
	public boolean two(int x1,int y1,int x2,int y2){
		//向左
		for(int i=x1-1; i>-1; i--){
			if(checkArr[i][y1]!=0){
				break;
			}
			if( one(i,y1,x2,y2)){
				return true;
			}
		}
		//向右
		for(int i=x1+1; i<checkArr.length; i++){
			if(checkArr[i][y1]!=0){
				break;
			}
			if(one(i,y1,x2,y2)){
				return true;
			}
		}
		//向上
		for(int i=y1-1; i>-1; i--){
			if(checkArr[x1][i]!=0){
				break;
			}
			if(one(x1,i,x2,y2)){
				return true;
			}
		}
		//向下
		for(int i=y1+1; i<checkArr.length; i++){
			if(checkArr[x1][i]!=0){
				break;
			}
			if(one(x1,i,x2,y2)){
				return true;
			}
		}
		return false;
	}
	
	private void drawLine(int x1, int y1, int x2, int y2){
		g.setColor(Color.RED);
		
		
	}
	
	private void pause(long time){
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
